stages:
  - pre
  - build
  - test
  - deploy

## SLSA attestation (level 1)
variables:
  REPO_NAME: gitlab.com/gitlab-code-challenge/oss-na-2023
  RUNNER_GENERATE_ARTIFACTS_METADATA: 1

welcome:
  image: alpine:latest
  stage: pre
  script:
    - echo "Welcome to the GitLab Code Challenge @ OSS NA 2023"

## Image converter, fix the output and tests (level 2)
before_script:
  - mkdir -p $GOPATH/src/$(dirname $REPO_NAME)
  - ln -svf $CI_PROJECT_DIR $GOPATH/src/$REPO_NAME
  - cd $GOPATH/src/$REPO_NAME

.go-tmpl:
  image: golang:1.20-alpine3.16

# Build job will run, inspect the job output after enabling SLSA attestation metadata (level 1)
build:
  extends: .go-tmpl
  stage: build
  script:
    - go build -o tanuki
  artifacts:
    paths:
      - ./tanuki

# This will fail and needs code fixes in main.go (level 2)
test:
  extends: .go-tmpl
  stage: test
  script:
    - go test -v

# After fixing the tests, inspect the deploy job for the CI/CD terminal output (level 2)
deploy:
  extends: .go-tmpl
  stage: deploy
  variables:
    IMAGE_PATH: "assets/tanuki.png"
    #IMAGE_PATH: "assets/love.png" # Hint: Try enabling this variable as a bonus.
  script:
    - ./tanuki
  artifacts:
    paths:
      - ./tanuki
